

Program apimatrix;

uses
  Windows,
  Messages,
  SysUtils,
  Graphics;

type TRect = record
  Left, Top, Right, Bottom: Integer;
end;

type
  TVertice=Record
    x,y,z:single;
end;

type
  TPolygon=Record
    typ:integer; //Type 0=Grafik 1=Rahmen Polygon fr Kollisionscheck
    color: TColor; //Farbe des Polygons
    Texture: integer; //Tapetenoffset
    collision:bool;    //Collisionsprfung bei Polygon?
    DrawCou:integer; //Anzahl Vertices des Polygons
    Draw: array of integer; //Offsets der Vertices
end;

type
  TObjekt=RECORD
    typ:byte;                 //Type des Objekts (wird nicht verwendet)
    CollObj:integer;          //Bei Kollision Wert gleich Offset des anderen Gegenstandes
    VertCount: integer;       //Anzahl Vertices im Objekt
    vert:array of TVertice;   //diverse Vertices
    PolyCou:integer;          //Anzahl Polygone im Objekt
    poly:array of TPolygon;   //Polygonzeiger
end;

type
  TStatic=Record     //Statisches Objekt
    dx,dy,dz:single;
    umx,umy,umz:single;
    ob:integer;      //Objekt
end;

type
  TQuadrant=RECORD
    co:integer; //Anzahl Objekte im Quadranten
    st:array of TStatic; //Zeiger auf diverse Objekte in dem Quadranten
end;

type
  TActor=Record
    x,y,z:single;	   //Position in der Welt
    umx,umy,umz:single;    //Letzte Winkel (Winkel um X-Achse ...)
    lx,ly,lz:Single;	   //Letzte Position (last x, last y ...)
    lumx,lumy,lumz:single; //Letzte Winkel (last Winkel um X ...)
    ob:integer;		   //Objekt Offset (Welches Objekt verwendet der Actor)
    sp:single;  	   //Speed des Actors
    quadrant:integer; //In welchem Quadranten steckt der Actor gerade?
end;


Type
  TLines=Record
    Ob:integer;		   //auf Kollision zu prfende Linie gehrt zu welchem Objekt?
    x1,y1,x2,y2:single;	   //2D-Koordinaten der Linie, die auf Kollision geprft werden soll
end;

const
  AppName = 'API';	   //Application-Name
  pi=3.1428;		   //Konstante fr Ausrechnung Bogenmass des Winkels

var
  //Allgemeine System Verwaltung
  AMessage:TMsg;			//Systemmessage Struktur/Record
  HWindow:HWND;				//Handle auf das Window
  WindowClass:TWndClass; 		//neue Fensterklasse im System
  taste: array [0..255] of bool;	//Feld mit gedrckten Tastaturwerten
  lastkey: integer;			//Welche Taste war die letze - dient nur der Anzeige
  running: bool = true; 		//Solange running=true -> Programm aktiv
  sysmes: bool; 			//Ergebnis von GetMessage Funktion am Ende des Prgs.
  dc: HDC; 				//Gertekontext Fenster
  canvas: TCanvas;			//Standard Grafikplattform
  //Frames per Second Verwaltung
  ifps:integer;				//Momentan F/s
  lastfps:integer;			//letzter F/S Wert - Grundlage fr Syncronisation
  itimold,itimnew,itimdel:integer;	//Hilfsvariablen F/S
  
  //Fenster und Bitmaps
  bg:TBitmap;				//Bitmap, in der gezeichnet wird
  myRect:Windows.TRect;			//fr Grsse der Bitmap in Pixel
  winheight,winwidth:integer;		//fr def. Grsse des Windows

  qua: array of TQuadrant;	//Matrix Array stellt die Quadranten der Welt dar
  obj: array of TObjekt;	//Objekt Array enthlt die diversen Objekte in einem Quadranten
  act: array of TActor;		//Actor (Objekt, da durch den Anwender gesteuert wird) Array
  lin: array of TLines;		//Linien Array - Dort werden die Linien der Welt gespeichert, die mit den Actoren auf Kollision vergliechen werden
  Actors:integer; //Wieviele Acteure gibt es
  xsize:integer;		//Die Welt besteht aus wieviel Quadranten in X-Richtung/horizontal
  xori,yori,zori:single;	//Origin X,Y,Z - wo ist der Mittelpunkt des Bildschirms?
  ac,oo:integer; 		//Offset Actor , Objekt-Offset
  x,y,z:single; 		//Rotations-Procedure Incoming
  ux,uy,uz:single ; 		//Rotationswerte in Rotationsprocedure
  nx,ny,nz:single; 		//Rotations-Procedure outgoing - Ergebnis der Rotation - neue x,y,z-Punkte
  alpha,beta,gamma:single; 	//Bogenmass Winkel eines gesamten Objekts (nur Actor)
  bShowCLines:boolean; //Sollen die Kollisionslinien gezeigt werden

  //Variablen Kollisionsprfung
  lines,maxlines:integer; 	//Zhler gespeicherter Kollisions-Prf-Linien, MAx. Anzahl Kollisionslinien
  kreuzpunkt_ab:single;  	//Kreuzp. Streck A nach B
  kreuzpunkt_cd:single;  	//Kreuzp. Streck B nach C
  kreuzpunkt_x:single;   	//Koordinate Treffpunkt X
  kreuzpunkt_y:single;   	//Koordinate Treffpunkt Y
  collicount:integer;		//Wieviele Kollisionen finden zwischen Actor und Hinderniss-Polygon statt?

//--------------------------------------
//bentigte Proceduren und Funktionen...
//--------------------------------------

//Werte setzen
procedure setzevars;
begin
  //Allgemein (Screen)
  winwidth:=640;
  winheight:=400;
  myRect.left:=2;
  myRect.top:=26;
  myRect.right:=winwidth-2;
  myRect.bottom:=winheight-2;
  xori:=trunc(winwidth/2);	//Wo ist der X Mittelpunkt des Fensters
  yori:=trunc(winheight/2);	//Wo ist der y Mittelpunkt des Fensters
  //Timing
  ifps:=0;
  itimnew:=gettickcount;
  itimold:=itimnew;
  //Kollisionslinien Feld lin
  bShowCLines:=true;
  maxlines:=1000;
  SetLength(lin,maxlines);
  //Welt
  XSize:=1; 			//Welt bestetht aus 1*n Quadranten
  SetLength(qua,100); 		//100 Quadranten sollen erst mal in der Welt (Matrix) reichen
  SetLength(Obj,100);  		//100 Objekte insgesamt tuns auch
  //
  Actors:=2;

  //Rahmendaten des Actors
    SetLength(act,actors);		//Array fr n Acteure dimensioniert
    ac:=0;			//Offset des einzigen Actors
    act[ac].x:=0;		//Position in der Welt <X>
    act[ac].y:=0;		//Position in der Welt <Y>
    act[ac].umz:=0;		//Drehwinkel um Z Achse (Vogelperspektive, 2D Scenario)
    act[ac].ob:=1;  		//Offset Objekt (gleich dreieckiges Objekt)
    act[ac].sp:=0.2;  		//Anfangsspeed
    act[ac].quadrant:=0;  //Start im Quadranten 0

    SetLength(act,actors);		//Array fr n Acteure dimensioniert
    ac:=1;			//Offset des einzigen Actors
    act[ac].x:=60;		//Position in der Welt <X>
    act[ac].y:=60;		//Position in der Welt <Y>
    act[ac].umz:=0;		//Drehwinkel um Z Achse (Vogelperspektive, 2D Scenario)
    act[ac].ob:=1;  		//Offset Objekt (gleich dreieckiges Objekt)
    act[ac].sp:=0.05;		//Anfangsspeed
    act[ac].quadrant:=0;  //Start im Quadranten 0

    ac:=0;

  //HINDERNISS Objekt definieren (Quadrat)
    Obj[0].Typ:=1; 		    //Type 1=Hinderniss (wird nicht weiter abgefragt, da Kollisionsschalter auch im einzelnen Polygon)
    Obj[0].CollObj:=0;
    Obj[0].VertCount:=4;                     //4 Vertices hat dieses Objekt 0
    SetLength(Obj[0].Vert,Obj[0].VertCount); //Dimensionierung Array Vert
    Obj[0].Vert[0].x:=-10;                    //Vertice 1
    Obj[0].Vert[0].y:=-10;
    Obj[0].Vert[0].z:=0;
    Obj[0].Vert[1].x:=+10;                    //Vertice 2
    Obj[0].Vert[1].y:=-10;
    Obj[0].Vert[1].z:=0;
    Obj[0].Vert[2].x:=+10;                    //Vertice 3
    Obj[0].Vert[2].y:=+10;
    Obj[0].Vert[2].z:=0;
    Obj[0].Vert[3].x:=-10;                    //Vertice 4
    Obj[0].Vert[3].y:=+10;
    Obj[0].Vert[3].z:=0;

    Obj[0].PolyCou:=2; 		//Anzahl Polygone im Objekt
    SetLength(Obj[0].Poly,Obj[0].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 0
    //Polygon 0 im Objekt 0
      Obj[0].poly[0].typ:=0; //0=Rahmenpolygon zwecks Kollisionsprfung
      Obj[0].poly[0].color:=rgb(10,10,10);
      Obj[0].poly[0].Texture:=0;
      Obj[0].poly[0].collision:=true;
      Obj[0].poly[0].DrawCou:=5;
      SetLength(Obj[0].poly[0].Draw,Obj[0].poly[0].DrawCou);
      Obj[0].poly[0].draw[0]:=0;
      Obj[0].poly[0].draw[1]:=1;
      Obj[0].poly[0].draw[2]:=2;
      Obj[0].poly[0].draw[3]:=3;
      Obj[0].poly[0].draw[4]:=0;
    //Polygon 1 im Objekt 0
      Obj[0].poly[1].typ:=1; //Grafikpolygon, dass nicht der Kollisionsprfung dient
      Obj[0].poly[1].color:=rgb(10,10,10);
      Obj[0].poly[1].Texture:=0;
      Obj[0].poly[1].collision:=false;
      Obj[0].poly[1].DrawCou:=5;
      SetLength(Obj[0].poly[1].Draw,Obj[0].poly[1].DrawCou);
      Obj[0].poly[1].draw[0]:=0;
      Obj[0].poly[1].draw[1]:=1;
      Obj[0].poly[1].draw[2]:=2;
      Obj[0].poly[1].draw[3]:=3;
      Obj[0].poly[1].draw[4]:=0;

  //FAHRZEUG Objekt definieren (Dreieck)
    Obj[1].Typ:=0; 		    //Type 0 = Actor
    Obj[1].CollObj:=0;    //mit wem kollidiert? bisher noch mit niemanden
    Obj[1].VertCount:=3;                     //3 Vertices hat dieses Objekt 1
    SetLength(Obj[1].Vert,Obj[1].VertCount); //Dimensionierung Array Vert
    Obj[1].Vert[0].x:=0;                    //Vertice 1
    Obj[1].Vert[0].y:=-10;
    Obj[1].Vert[0].z:=0;
    Obj[1].Vert[1].x:=+10;                  //Vertice 2
    Obj[1].Vert[1].y:=+10;
    Obj[1].Vert[1].z:=0;
    Obj[1].Vert[2].x:=-10;                  //Vertice 3
    Obj[1].Vert[2].y:=+10;
    Obj[1].Vert[2].z:=0;

    Obj[1].PolyCou:=2; 		//Anzahl Polygone im Objekt
    SetLength(Obj[1].Poly,Obj[1].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 1
    //Polygon 0 im Objekt 1
      Obj[1].poly[0].typ:=0; //0=Rahmenpolygon zwecks Kollisionsprfung
      Obj[1].poly[0].color:=rgb(0,255,0);
      Obj[1].poly[0].Texture:=0;
      Obj[1].poly[0].collision:=true;
      Obj[1].poly[0].DrawCou:=4;
      SetLength(Obj[1].poly[0].Draw,Obj[1].poly[0].DrawCou);
      Obj[1].poly[0].draw[0]:=0;
      Obj[1].poly[0].draw[1]:=1;
      Obj[1].poly[0].draw[2]:=2;
      Obj[1].poly[0].draw[3]:=0;
    //Polygon 1 im Objekt 0
      Obj[1].poly[1].typ:=1; //Grafikpolygon, dass nicht der Kollisionsprfung dient
      Obj[1].poly[1].color:=rgb(0,255,0);
      Obj[1].poly[1].Texture:=0;
      Obj[1].poly[1].collision:=false;
      Obj[1].poly[1].DrawCou:=4;
      SetLength(Obj[1].poly[1].Draw,Obj[1].poly[1].DrawCou);
      Obj[1].poly[1].draw[0]:=0;
      Obj[1].poly[1].draw[1]:=1;
      Obj[1].poly[1].draw[2]:=2;
      Obj[1].poly[1].draw[3]:=0;


  //Quadrant definieren (Matrix mit einzelnen Objekten bestcken)
  qua[0].co:=3; 			//Anzahl zugewiesener Objekte im Quadranten 0
  SetLength(qua[0].st,qua[0].co);

  qua[0].st[0].dx:=-100;		//Wo ist das Objekt im Quadranten? (Delaywerte x,y,z)
  qua[0].st[0].dy:=100;
  qua[0].st[0].dz:=0;
  qua[0].st[0].ob:=0; 			//an der Stelle soll Objekt 0 gesetzt werden

  qua[0].st[1].dx:=-30;  		//noch ein Objekt weiter rechts im Quadranten 0
  qua[0].st[1].dy:=-20; 		//weiter unten
  qua[0].st[1].dz:=0;
  qua[0].st[1].ob:=0; 			//an dieser Stelle soll auch Objekt 0 gesetzt werden

  qua[0].st[2].dx:=60;			//noch ein Objekt 0 in dem Quadranten 0 setzen...
  qua[0].st[2].dy:=120;
  qua[0].st[2].dz:=0;
  qua[0].st[2].ob:=0;
end;

//Bewegungswerte der Frames per Second Frequenz anpassen - je mehr Frams, desto kleiner der Bewegungswert
function sync(wert:single):single;
begin
  if lastfps=0 then exit;	//Keine Division durch Null zulassen
  result:=wert/lastfps;		//Ergebnis gleich Bewegungswert durch Anzahl Bilder pro Sekunde
end;

procedure tastatur;
begin
  //Alte Werte merken		//Beovr der Actor eine neue Drehposition einnimmt, bitte die aktuelle Position merken
  act[ac].lumx:=act[ac].umx;
  act[ac].lumy:=act[ac].umy;
  act[ac].lumz:=act[ac].umz;
  //nun Tasten prfen...
  if taste[vk_escape] then running:=false;		//Programmende durch ESC Taste
  if taste[39] then act[ac].umz:=act[ac].umz+sync(90);	//Pfeil rechts (Actor dreht sich um die Z-Achse nach rechts)
  if taste[37] then act[ac].umz:=act[ac].umz-sync(90);	//Pfeil links
  if taste[38] then act[ac].sp:=act[ac].sp+sync(0.5);	//Pfeil hoch	(Vorwrts beschleunigen)
  if taste[40] then act[ac].sp:=act[ac].sp-sync(0.5);	//Pfeil runter	(rckwrts beschleunigen)
  if taste[vk_f1] then
  begin
    inc(ac); if ac=actors then ac:=0; taste[vk_f1]:=false;
  end;
  { F-Tasten sind wrden durch taste[vk_f1] bis taste[vk_f12] abgefragt werden }
end;

procedure begrenzung;
var
  la:integer;
begin
  for la:=0 to actors-1 do
  begin
    //Drehwinkel des Actors im gewohnten Winkelbereich halten (muss nicht unbedingt)
    if act[la].umz>360 then act[la].umz:=act[la].umz-360;
    if act[la].umz<0 then act[la].umz:=act[la].umz+360;
    //Geschwindigkeit begrenzen des Actors
    if act[la].sp>2 then act[la].sp:=2;
    if act[la].sp<-1 then act[la].sp:=-1;
  end;
end;

//Frames per Second besorgen
procedure zeitmessung;
begin
  inc(ifps);
  itimnew:=gettickcount;	//Millisekunden Zhler seit Systemstart
  itimdel:=itimnew-itimold;
  if itimdel>1000 then		//nach Sekunde Zhlergebnis merken...
  begin
    itimold:=itimnew;
    lastfps:=ifps;		//...in lastfps
    ifps:=0;
  end;
end;

//Etwas auf dem Schirm anzeigen
procedure screentext;
begin
  bg.canvas.textout(20,32,'<F1=Switch Actor> Taste='+inttostr(lastkey)+'   F/S='+inttostr(lastfps));
end;

//Objekte zeichen
procedure drawStatic;
var
  la,lm,lp,ld:integer;		//for "L"oop- ... Variablen
  quadrant:integer; 			//Matrix/Quadrantenoffset
  oof:integer;			//Offset eines Objekts
  odx,ody,odz:single;		//Delaywert eines Objekts (wo ist es in der Welt?)
  dtype:integer; //Drawtype Polygon Rahmen, Grafik ...
  vertice:integer; //Offset Vertice
  xv0,yv0,zv0:single; //Wert des Vertices
  qmerk:string;
begin
  //Zeichnen
  for la:=0 to Actors-1 do
  begin
    quadrant:=Act[la].quadrant;
    if pos(inttostr(quadrant),qmerk)=0 then //keinen Quadranten doppelt bearbeiten
    begin
      qmerk:=qmerk+','+inttostr(quadrant); //Quadrant als schon bearbeitet merken
      if qua[quadrant].co>0 then		//nur behandeln, wenn auch Objekte da sind
      begin
        //Objekt im Quadrant
        for lm:=0 to qua[quadrant].co-1 do 		//Alle Objekte verarbeiten
        begin
          odx:=qua[quadrant].st[lm].dx+xori+act[ac].x; 	//Delay X des Objekts in der Welt (Verschiebung = X-Pos Objekt + Mitte Window + Position des Actors)
          ody:=qua[quadrant].st[lm].dy+yori+act[ac].y; 	//Delay Y
          odz:=qua[quadrant].st[lm].dx+zori; 	  	//Delay Z
          oof:=qua[quadrant].st[lm].ob; 		  	//Offset Objekt
          //Polygone des Objekts
          for lp:=0 to Obj[oof].PolyCou-1 do
          begin
            if Obj[oof].Poly[lp].typ=1 then //Rahmenobjekt?
            begin
              for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
              begin
                with bg.Canvas do				//auf bg.canvas beziehen...
                begin
                  vertice:=Obj[oof].Poly[lp].draw[ld]; //Offset Vertice des Objekts
                  xv0:=Obj[oof].vert[vertice].x+odx;  //x
                  yv0:=Obj[oof].vert[vertice].y+ody;  //y
                  zv0:=Obj[oof].vert[vertice].z+odz;  //z
                  if bShowCLines then
                    if ld=0 then moveto(trunc(xv0),trunc(yv0)) else
                      lineto(trunc(xv0),trunc(yv0));
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

//Rotieren um Achsen
//bergeben werden
//	x,y,z (Punkt wird um 0,0,0 rotiert)
//	umx,umy,umz (Um welche Achse rotieren - Angabe in Grad)
// Ergebnis sind die neuen Koordinaten
//	nx,ny,nz
procedure Rotation;
var
  x1,y1,z1:single;
begin
  // Rotation um die x-Achse
  x1:=x;
  y1:=(y*cos(alpha)-z*sin(alpha));
  z1:=(y*sin(alpha)+z*cos(alpha));
  // Rotation um die Y-Achse
  x:=(x1*cos(beta)-z1*sin(beta));
  y:=y1;
  z:=(x1*sin(beta)+z1*cos(beta));
  // Rotation um die Z-Achse
  z1:=z;
  x1:=(x*cos(gamma)-y*sin(gamma));
  y1:=(x*sin(gamma)+y*cos(gamma));
  {//Datenumrechnung fr die 2D Darstellung (hier berflssig)
  //q:=trunc((x1+dx)*fac/(c1+zoom)+xori); //dx=Delaywert fac=Manipulationsfaktor zoom=Zoomwert xori=Windowmitte q=neuer 2D Wert X Achse
  //w:=trunc((y1+dy)*fac/(c1+zoom)+yori);}
  // Werte speichern
  nx:=x1;
  ny:=y1;
  nz:=z1;
end;

//findet Kollision zwischen zwei Linien statt?
//bergabe 
//	ax,ay,bx,by - Linie 1
//	cx,cy,dx,dy - Linie 2
//Ergebnis
//	Bool Result -> bei Kollision = true
//	kreuzpunkt_x und kreuzpunkt_y -> wo fand das crossing statt
function collision(ax,ay,bx,by,cx,cy,dx,dy:single):bool;
var
  rn,rd,sn:single;       //Hilfsvariablen der Funktion
begin
  rd:=(bx-ax)*(dy-cy)-(by-ay)*(dx-cx);
  If rd=0
    then result:=False
  else
    begin
      rn:=(ay-cy)*(dx-cx)-(ax-cx)*(dy-cy);
      sn:=(ay-cy)*(bx-ax)-(ax-cx)*(by-ay);
      kreuzpunkt_ab:=rn/rd;
      kreuzpunkt_cd:=sn/rd;
      kreuzpunkt_x:=ax+kreuzpunkt_ab*(bx-ax);
      kreuzpunkt_y:=ay+kreuzpunkt_ab*(by-ay);
      if (kreuzpunkt_ab<0) Or (kreuzpunkt_ab>1) Or (kreuzpunkt_cd<0) Or (kreuzpunkt_cd>1)
        Then  result:=false
      else result:=true;
    end;
end;

//Acotr zeichen
procedure drawActor;
var
  la,lm,lp,ld:integer;		//for "L"oop- ... Variablen
  oof:integer;			//Offset eines Objekts
  odx,ody,odz:single;		//Delaywert eines Objekts (wo ist es in der Welt?)
  vertice:integer; //Offset Vertice
  xv0,yv0,zv0:single; //Wert des Vertices
begin
  //Zeichnen
  for la:=0 to Actors-1 do
  begin
    oof:=Act[la].ob;
    ux:=act[la].umx; //Rotation um X
    uy:=act[la].umy; //Rotation um Y
    uz:=act[la].umz; //Rotation um Z
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
    //Polygone des Objekts
    for lp:=0 to Obj[oof].PolyCou-1 do
    begin
      if Obj[oof].Poly[lp].typ=1 then //Rahmenobjekt?
      begin
        for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
        begin
          with bg.Canvas do				//auf bg.canvas beziehen...
          begin
            vertice:=Obj[oof].Poly[lp].draw[ld]; //Offset Vertice des Objekts
            x:=Obj[oof].vert[vertice].x;  //x
            y:=Obj[oof].vert[vertice].y;  //y
            z:=Obj[oof].vert[vertice].z;  //z
            Rotation;
            if la=ac then //Actor in Bildschirmmitte zeichnen
              begin
                odx:=nx+xori;
                ody:=ny+yori;
                odz:=nz+zori;
              end
            else  //sonst dahin wo er hin gehrt
              begin
                odx:=act[AC].x+nx+xori-act[la].x;
                ody:=act[AC].y+ny+yori-act[la].y;
                odz:=act[AC].z+nz+zori-act[la].z;
              end;
            if bShowCLines then
              if ld=0 then moveto(trunc(odx),trunc(ody)) else
                lineto(trunc(odx),trunc(ody));
          end;
        end;
      end;
    end;
  end;
end;


{
//Actor zeichnen und Collision durchfhren - hier wird davon ausgegangen, dass der Actor aus Dreiecken besteht!
procedure drawActor;
var
  lp:integer;
  oof:integer;
  odx,ody,odz:single;
  Polygone,Vertices:integer;
  f1x,f1y,f1z:single;
  f2x,f2y,f2z:single;
  f3x,f3y,f3z:single;
  colli:bool;
  lc:integer;
begin
  collicount:=0;
  //
  oof:=act[ac].ob; //Offset Objekt
  ux:=act[ac].umx; //Rotation um X
  uy:=act[ac].umy; //Rotation um Y
  uz:=act[ac].umz; //Rotation um Z
  alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
  //Polygone des Objekts
  Polygone:=Obj[oof].co; //Anzahl Polygone pro Objekt
  for lp:=0 to Polygone-1 do
  begin
    Vertices:=Obj[oof].po[lp].cou; //Anzahl Vertices pro Polygon
    with bg.Canvas do
    begin
      //Dreieck Punkt 1
      x:=Obj[oof].po[lp].x0; y:=Obj[oof].po[lp].y0; z:=0;
      Rotation;
      f1x:=nx+xori; f1y:=ny+yori; f1z:=nz;
      moveto(trunc(f1x),trunc(f1y));
      //Dreieck Punkt 2
      x:=Obj[oof].po[lp].x1; y:=Obj[oof].po[lp].y1; z:=0;
      Rotation;
      f2x:=nx+xori; f2y:=ny+yori; f2z:=nz;
      lineto(trunc(f2x),trunc(f2y));
      //Dreieck Punkt 3
      x:=Obj[oof].po[lp].x2; y:=Obj[oof].po[lp].y2; z:=0;
      Rotation;
      f3x:=nx+xori; f3y:=ny+yori; f3z:=nz;
      lineto(trunc(f3x),trunc(f3y));
      //Zurck zu Punkt 1
      lineto(trunc(f1x),trunc(f1y));
      //Drei gezeichnete Linien des Acotrs mit den Linien der Hindernisse auf Kollision prfen
      for lc:=0 to lines-1 do
      begin
        colli:=false; 
        if not colli then colli:=collision(f1x,f1y,f2x,f2y,lin[lc].x1,lin[lc].y1,lin[lc].x2,lin[lc].y2);
        if not colli then colli:=collision(f2x,f2y,f3x,f3y,lin[lc].x1,lin[lc].y1,lin[lc].x2,lin[lc].y2);
        if not colli then colli:=collision(f3x,f3y,f1x,f1y,lin[lc].x1,lin[lc].y1,lin[lc].x2,lin[lc].y2);
        if colli then
        begin
          inc(collicount); 		//Fr andere Procedur merken, dass Collision stattfand
          bg.canvas.TextOut(trunc(kreuzpunkt_x-4),trunc(kreuzpunkt_y-4),'X');	//An Kollisionsstelle ein X printen
        end;
      end;
    end;
  end;
  //Position des Actors bei Collision zurcksetzen / Actor nimmt die Position vor dem Zusammensto an
  if collicount>0 then
  begin
    act[ac].x:=act[ac].lx;
    act[ac].y:=act[ac].ly;
    act[ac].z:=act[ac].lz;
    act[ac].umx:=act[ac].lumx;
    act[ac].umy:=act[ac].lumy;
    act[ac].umz:=act[ac].lumz;
  end;
end;
}

procedure Bewegung;
var
  la:integer;
  odx,ody,odz:single;
  Polygone,Vertices:integer;
  fx,fy,fz:single;
begin
  for la:=0 to actors-1 do
  begin
    //Aktuelle Werte speichern fr Rcksetzung nach einer eventuellen Kollision
    act[la].lx:=act[la].x;
    act[la].ly:=act[la].y;
    act[la].lz:=act[la].z;
    //dann neue errechnen
    ux:=act[la].umx; //Rotation um X
    uy:=act[la].umy; //Rotation um Y
    uz:=act[la].umz; //Rotation um Z
    //Die neue Position des Actors ergibt sich aus dem Radius (der gleich der Geschwindigkeit ist) gedreht um den Winkel um die Z Achse
    //Da wo diese gedachte Linie von der Mitte des Actors aus betrachtet aufhrt, ist die neue Koordinate des Actors
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt
    y:=act[la].sp; 	//Radius der Rotation = Speed des Actors
    x:=0;  z:=0;		//Spielen in der 2D Darstellung hier keine Rolle
    Rotation;
    act[la].x:=act[la].x+nx;  act[la].y:=act[la].y+ny;  act[la].z:=act[la].z+nz; 	//Position um neue Werte erweitern
  end;
end;

//Fensterfunktion - wird nur aufgerufen wenn Message vorhanden ist - z.B. Mausklick, Mausbewegung, ...
//The WindowProc function is an application-defined callback function that processes messages sent to a window.
function WindowProc(Window: HWND; AMessage,WParam,LParam: LongInt): LongInt; stdcall; export;
begin
  WindowProc:=0;
  case AMessage of        		//Nachrichten auswerten
    wm_keydown:
      begin
        taste[wparam]:=true;
        lastkey:=wparam;
      end;
    wm_keyup:
      begin
        taste[wparam]:=false;
      end;
    wm_LButtonDown:             	//linke Maustaste gedrueckt?
      begin
      //Beep(100,800);
      end;
    wm_Destroy:                 	//X-oben rechts geklickt zum schliessen der api?
      begin
        PostQuitMessage(0);
        exit;
      end;
  end;
//Standardverarbeitung fr alle anderen Botschaften (Fenster verschieben Grosse verndern...)
//The DefWindowProc function calls the default window procedure to provide default processing for any window messages that an application does not process. This function ensures that every message is processed. DefWindowProc is called with the same parameters received by the window procedure.
  WindowProc:=DefWindowProc(Window,AMessage,WParam,LParam);
end;

//----------------------------
//Programmablauf und Schleife
//----------------------------

begin 							//Startmarke

//Variablen setzen
  setzevars;

//Fensterklasse registrieren
  WindowClass.style:=cs_hRedraw or cs_vRedraw;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.cbCLsExtra:=0;
  WindowClass.cbWNDExtra:=0;
  WindowClass.hInstance:=HInstance;
  WindowClass.hIcon:=loadIcon(0,idi_Application);
  WindowClass.hCursor:=loadcursor(0,idc_Arrow);
  WindowClass.hbrBackground:=HBrush(Color_window);
  WindowClass.lpszMenuName:=nil;
  WindowClass.lpszClassName:=AppName;

  if RegisterClass(WindowClass)=0 then exit; //Wenn Registrierung i.o. dann weiter sonst ende

//Fenster erzeugen
  winwidth:=640;
  winheight:=400;
  hWindow:=createWindow(Appname,'APIMATRIX',ws_Overlappedwindow,
           cw_UseDefault, cw_UseDefault,winwidth,winheight,
           0,0,Hinstance,nil);

//Fenster anzeigen
  if hWindow<>09 then
    begin
    ShowWindow(hWindow,CmdShow); //The ShowWindow function sets the specified window's show state.
    UpdateWindow(hWindow); //The UpdateWindow function updates the client area of the specified window by sending a WM_PAINT message to the window if the window's update region is not empty. The function sends a WM_PAINT message directly to the window procedure of the specified window, bypassing the application queue. If the update region is empty, no message is sent.
    end
  else
    exit;

//Fensterkontext fr Graphicausgabe holen
  canvas:=TCanvas.Create;
  dc:=GetWindowDC(HWindow); //Gertekontext des Fensters holen
  canvas.Handle:=dc; //Zeichenobjekt zugewiesen

//zeichen Hintergrundbitmap machen
  bg:=TBitmap.Create;
  bg.height:=winheight;
  bg.width:=winwidth;

//Message Loop - Hauptschleife
  while running do
  begin
    sysmes:=PeekMessage(AMessage,0,0,0,PM_Remove); //aktuelle Botschaften vom System abfangen ohne den Prosses anzuhalten
    if sysmes then //wenn Message, dann hier weiter machen
    begin
      if Amessage.message=WM_QUIT then
        begin
          running:=false; //Programm soll beendet werden
        end
        else //ansonsten normale Windows Messages weiter verarbeiten
        begin
          TranslateMessage(AMessage); //The TranslateMessage function translates virtual-key messages into character messages. The character messages are posted to the calling thread's message queue, to be read the next time the thread calls the GetMessage or PeekMessage function.
          DispatchMessage(AMessage); //The DispatchMessage function dispatches a message to a window procedure. It is typically used to dispatch a message retrieved by the GetMessage function.
        end;
    end;
      sleep(5);			//fr bessere Integration der Anwendung im System
    //automatische Bewegung
      bewegung; 		//neue Position der Welt um den Actor ausrechnen
    //Grafikprozess
      bg.canvas.fillrect(MyRect); 		//Screen leeren
      drawStatic;					//Hindernisse zeichnen
      drawActor;				//Actor zeichnen
      screentext;  				//Info auf Screen
      canvas.copyrect(myrect,bg.canvas,myrect); //Swap gfx - das im Hintergrund gezeichnete sichtbar machen
    //weiter
      zeitmessung; 				//Frames per Second ermitteln
      tastatur; 				//Tastaturabfrage wird kontinuierlich aufgerufen
      begrenzung;				//genderte Werte eventuelle im Zaum halten
  end;

//Programmende
  bg.free; 					//Zeichenbitmap freigeben
  releaseDC(0,dc); 				//Gertekontext fr Grafikausgabe auflsen
  Halt(AMessage.wParam);  			//Die Prozedur Halt lst einen Programmabbruch aus und gibt die Steuerung an das Betriebssystem zurck
end. 						//Endmarke




